CSL 5.2

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Public Attributes | Protected Member Functions | Protected Attributes
csl::MP3File Class Reference

MP3File - decodes MP3s into a buffer upon openForRead() More...

`#include <SoundFileMP3.h>`

Inheritance diagram for csl::MP3File:

List of all members.

## Public Member Functions
| MP3File (string path="", int start=-1, int stop=-1)
| Constructor.
| MP3File (float maxDurInSecs, string path)
| ~MP3File ()
void | openForRead () throw (CException)
| open file and get stats
void | openForWrite (SoundFileFormat format=kSoundFileFormatAIFF, unsigned channels=1, unsigned rate=44100, unsigned bitDepth=16) throw (CException)
| Open a file for write (an error for decoded files).
void | openForReadWrite () throw (CException)
| open r/w (error) seek to some position
void | nextBuffer (Buffer &outB) throw (CException)
| copy next buffer from cache
virtual void | nextBuffer (Buffer &outputBuffer, unsigned outBufNum) throw (CException)
| really compute the next buffer given an offset base channel; this is called by nextBuffer, possibly multiple times
bool | writeBuffer (float *stereo_buffer, unsigned num_samples)
| store samples into the receiver, adding another buffer if necessary. Returns true if we should do so, false if there are no more samples.
bool | writeBuffer (float *L_buffer, float *R_buffer, unsigned num_samples)
| store samples into the receiver, adding another buffer if necessary
bool | writeBuffer (int *L_buffer, int *R_buffer, unsigned num_samples)
void | writeBuffer (Buffer &inputBuffer) throw (CException)
| write a buffer of data into the file
SoundFileFormat | format ()
| get format
virtual void | openForRead (bool load=true) throw (CException)
| open file and get stats Open a file for write. Default values are some common format.
void | close ()
| close file seek to some position
unsigned | seekTo (int position, SeekPosition whence=kPositionStart) throw (CException)
| seek to some position relative to "whence"
unsigned | seekTo (int position) throw (CException)
| read a buffer from the file (possibly all of it)
void | readBufferFromFile (unsigned numFrames)
| read a buffer from the file (possibly all of it)
bool | isCached ()
| answer if file has all of its samples in RAM
bool | isCached (unsigned samps)
| answer if file has X samples in RAM
SF_INFO * | sfInfo ()
| libsndfile sf-info struct
SNDFILE * | sndFile ()
| libsndfile handle
virtual SampleBuffer | buffer (unsigned bufNum)
unsigned | channels () const
| accessors
unsigned | duration ()
| number of frames in the Seekable
float | durationInSecs ()
| number of frames in the sound file
unsigned | sampleSize ()
| get the bytes-per-sample
SoundFileMode | mode ()
| r/w mode
unsigned | cacheSize ()
| size in frames of cached portion
void | mergeToMono ()
| average all the channels to mono
virtual void | setToEnd ()
| set to end position
virtual void | trigger ()
| reset to start
virtual void | freeBuffer ()
| free the file cache
void | convertRate (int fromRate, int toRate)
| perform sample-rate conversion
bool | isValid ()
| answer if a valid file/buffer
bool | isActive ()
| answer if currently active
virtual void | setPath (string path)
| set file name path string
string | path ()
| file name
virtual void | dump ()
| log snd file props
int | startFrame ()
| get/set start frame
void | setStart (int val)
void | setStartSec (float val)
void | setStartRatio (float val)
int | stopFrame ()
| get/set stop frame
void | setStop (int val)
void | setStopSec (float val)
void | setStopRatio (float val)
void | setBase (int val)
unsigned int | base ()
double | playbackRate ()
| playback rate (pitch ratio)
void | setRate (UnitGenerator &frequency)
| set the receiver's playback rate (pitch ratio)
void | setRate (float frequency)
bool | isLooping ()
| get/set looping state
void | setIsLooping (bool tLooping)
void | setWaveform (Buffer &wave, bool freeBufs=true)
| plug in waveforms set the interpolation flag
void | setInterpolate (InterpolationPolicy whether)
unsigned | frameRate ()
void | setFrameRate (unsigned rate)
| get/set the receiver's frame rate
virtual unsigned | numChannels ()
void | setNumChannels (unsigned ch)
| get/set the receiver's number of outputs
BufferCopyPolicy | copyPolicy ()
void | setCopyPolicy (BufferCopyPolicy ch)
| get/set the receiver's buffer copy policy
virtual bool | isFixed ()
| query whether I'm fixed (StaticVariable overrides this)
void | addOutput (UnitGenerator *ugen)
| add to or return the UGen vector of outputs
void | removeOutput (UnitGenerator *ugen)
UGenVector | outputs ()
virtual unsigned | numOutputs ()
bool | checkFanOut (Buffer &outputBuffer) throw (CException)
| check for fan-out and copy previous buffer; return true if fanning out
void | handleFanOut (Buffer &outputBuffer) throw (CException)
virtual void | setValue (sample theValue)
| set/get the value (not allowed in the abstract, useful for static values)
virtual sample | value ()
void | attachObserver (Observer *)
| (possibly notify obersvers on my death)
void | detachObserver (Observer *)
void | changed (void *argument)
| this is what I send to myself to notify my observers; It's not overridden in general. It results in the observers receiving update() calls < override evaluate to filter updates to the observer map
virtual int | evaluate (void *argument)
void | setFrequency (UnitGenerator &frequency)
| Setter accessors.
void | setFrequency (float frequency)
| set frequency
void | setPhase (float phase)
Port * | getPort (CSL_MAP_KEY name)
void | setScale (UnitGenerator &scale)
| set the receiver's scale member to a UGen or a float
void | setScale (float scale)
void | setOffset (UnitGenerator &offset)
| set the receiver's offset member to a UGen or a float
void | setOffset (float offset)
void | isScaled ()
| answer whether scale = 1 & offset = 0
virtual void | reset () throw (CException)
| reset-to-zero

## Static Public Member Functions
static LSoundFile * | openSndfile (string path, int start=-1, int stop=-1, bool doRead=true)
| Factory method.
static LSoundFile * | openSndfile (float maxDurInSecs, string path)
static bool | isSndfileName (const char *path)
| Answer whether the given name looks like a snd file.
static SoundFileFormat | sndfileNameType (const char *path)
| Answer the snd file type.
static const char * | mimeType (const char *path)
| Answer the MIME type based on the file name.

## Public Attributes
unsigned | mMP3Rate
| the actual rate of the MP3 file
SoundFileMetadata * | mProperties
| the ID3 tags properties
InterpolationPolicy | mInterpolate
| whether/how I should interpolate between samples
Buffer | mWavetable
| the stored wave form
unsigned | mCurrentFrame
| where I currently am in the buffer
double | mActualFrame
| where I actually am in the buffer

## Protected Member Functions
int | decodeMP3 () throw (CException)
| decode an MP3 file into a buffer
virtual void | writeBuffer (Buffer &inputBuffer, unsigned bufNum) throw (CException)
| write to the receiver
void | mergeBuffers ()
| merge (concatenate) the buffers into 1 after loading
bool | checkBufferStack (unsigned numFrames)
bool | addBuffer (unsigned numChannels, unsigned numFrames)
unsigned | totalSize ()
| answer the total size of the buffer list
void | initFromSndfile ()
| read SF header
void | checkBuffer (unsigned numFrames)
| allocate buffer lazily
void | checkBuffer (unsigned numChans, unsigned numFrames)
bool | readTags () throw (CException)
| read the ID3 or other tags. Returns true if able to read them.
void | fillSine ()
| fill the shared wavetable with 1 cycle of a sine wave
void | zeroBuffer (Buffer &outputBuffer, unsigned outBufNum)
| utility method to zero out an outputBuffer
void | addInput (CSL_MAP_KEY name, UnitGenerator &ugen)
| Plug in a unit generator to the named input slot.
void | addInput (CSL_MAP_KEY name, float value)
| Plug in a float to the named input slot.
void | pullInput (Port *thePort, unsigned numFrames) throw (CException)
| method to read the control values (in case they're dynamic). this sends nextBuffer() to the input.
void | pullInput (Port *thePort, Buffer &theBuffer) throw (CException)

## Protected Attributes
BufferVector | mBuffers
| temp decoder buffers merge (concatenate) the buffers into 1 after loading
SF_INFO * | mSFInfo
| libsndfile sf-info struct
SNDFILE * | mSndfile
| libsndfile handle
Interleaver | mInterleaver
| File IO interleaver/deinterleaver.
float | mMaxDurInSecs
| max size to read from file. In seconds so it can deal with varying sample rates.
string | mPath
| file name
SoundFileMode | mMode
| r/w mode
SoundFileFormat | mFormat
| sf format
bool | mIsValid
| is my file valid?
bool | mIsLooping
| am i looping start-stop?
int | mStart
int | mStop
| starting/ending frames (or -1 if not used)
double | mRate
| sample rate ratio
unsigned | mNumFrames
| # sample frames
unsigned | mBytesPerSample
| the # of bytes per sample
unsigned | mBase
| starting frame in file of buffer
unsigned | mFrameRate
| trigger ignored here
unsigned | mNumChannels
| my "expected" number of output channels
BufferCopyPolicy | mCopyPolicy
| the policy I use if asked for more or fewer channels
UGenVector | mOutputs
| the vector of my output UGens
unsigned | mNumOutputs
| the number of outputs
Buffer * | mOutputCache
| my past output ring buffer (only used in case of fan-out)
unsigned | mSequence
| the highest-seen buffer seq number
sample | mPhase
| set phase
PortMap | mInputs
| the map of my inputs or controls (used by the mix-in classes)

## Detailed Description

MP3File - decodes MP3s into a buffer upon openForRead()

Definition at line 70 of file SoundFileMP3.h.

## Constructor & Destructor Documentation

MP3File::MP3File | ( | string | path = `""`,
|  | int | start = `-1`,
|  | int | stop = `-1`
| ) |  |

Constructor.

MP3File constructors.

Definition at line 443 of file SoundFileMP3.cpp.

References DEFAULT_MP3_RATE, csl::Abst_SoundFile::mMode, mMP3Rate, and openForRead().

MP3File::MP3File | ( | float | maxDurInSecs,
|  | string | path
| ) |  |

Definition at line 451 of file SoundFileMP3.cpp.

References DEFAULT_MP3_RATE, csl::Abst_SoundFile::mMode, mMP3Rate, and openForRead().

MP3File::~MP3File | ( |  | ) |

Definition at line 459 of file SoundFileMP3.cpp.

## Member Function Documentation

void MP3File::openForRead | ( |  | ) | throw (CException)

open file and get stats

openForRead decodes MP3 file into a temp file and plugs that into the receiver

Definition at line 463 of file SoundFileMP3.cpp.

References csl::Buffer::copyFrom(), decodeMP3(), kSoundFileRead, csl::LSoundFile::LSoundFile(), csl::UnitGenerator::mFrameRate, csl::Abst_SoundFile::mIsValid, csl::Abst_SoundFile::mMode, mMP3Rate, csl::UnitGenerator::mNumChannels, csl::Abst_SoundFile::mNumFrames, csl::LSoundFile::mSFInfo, csl::LSoundFile::mSndfile, csl::Abst_SoundFile::mStart, csl::Abst_SoundFile::mStop, csl::WavetableOscillator::mWavetable, and csl::Abst_SoundFile::readTags().

Referenced by MP3File().

int MP3File::decodeMP3 | ( |  | ) | throw (CException)
| protected

decode an MP3 file into a buffer

Definition at line 375 of file SoundFileMP3.cpp.

References csl::Buffer::allocateBuffers(), close_file(), CSL_LINE_LEN, csl::CGestalt::frameRate(), kSoundFileFormatAIFF, vbuffer::length, csl::logMsg(), csl::LSoundFile::LSoundFile(), m3_error(), m3_header(), m3_input(), m3_output(), csl::CGestalt::maxBufferFrames(), csl::DecodedFile::mBuffers, csl::DecodedFile::mergeBuffers(), csl::Buffer::mNumFrames, MP3_DEPTH, MP3_SAMP_TYPE, vbuffer::mp3File, csl::Abst_SoundFile::mPath, vbuffer::outBufs, csl::CGestalt::sndFileFrames(), and vbuffer::start.

Referenced by openForRead().

void DecodedFile::openForWrite | ( | SoundFileFormat | format = `kSoundFileFormatAIFF`,
|  | unsigned | channels = `1`,
|  | unsigned | rate = `44100`,
|  | unsigned | bitDepth = `16`
| ) |  | throw (CException)
| virtual inherited

Open a file for write (an error for decoded files).

Reimplemented from csl::LSoundFile.

Definition at line 255 of file SoundFileMP3.cpp.

void DecodedFile::openForReadWrite | ( |  | ) | throw (CException)
| inherited

open r/w (error) seek to some position

Reimplemented from csl::LSoundFile.

Definition at line 260 of file SoundFileMP3.cpp.

void DecodedFile::nextBuffer | ( | Buffer & | outB | ) | throw (CException)
| virtual inherited

copy next buffer from cache

Reimplemented from csl::LSoundFile.

Definition at line 266 of file SoundFileMP3.cpp.

void WavetableOscillator::nextBuffer | ( | Buffer & | outputBuffer,
|  | unsigned | outBufNum
| ) |  | throw (CException)
| virtual inherited

really compute the next buffer given an offset base channel; this is called by nextBuffer, possibly multiple times

Reimplemented from csl::UnitGenerator.

Reimplemented in csl::CompOrCacheOscillator.

Definition at line 129 of file Oscillator.cpp.

References DECLARE_PHASED_CONTROLS, DECLARE_SCALABLE_CONTROLS, csl::kLinear, csl::kTruncate, LOAD_PHASED_CONTROLS, LOAD_SCALABLE_CONTROLS, csl::logMsg(), mFrameRate, UPDATE_PHASED_CONTROLS, and UPDATE_SCALABLE_CONTROLS.

Referenced by csl::LSoundFile::nextBuffer(), csl::CompOrCacheOscillator::nextBuffer(), and csl::Abst_SoundFile::nextBuffer().

bool DecodedFile::writeBuffer | ( | float * | stereo_buffer,
|  | unsigned | num_samples
| ) |  |
| inherited

store samples into the receiver, adding another buffer if necessary. Returns true if we should do so, false if there are no more samples.

Definition at line 172 of file SoundFileMP3.cpp.

References csl::Buffer::buffer(), csl::DecodedFile::checkBufferStack(), csl::DecodedFile::mBuffers, csl::UnitGenerator::mFrameRate, csl::LSoundFile::mMaxDurInSecs, csl::UnitGenerator::mNumChannels, csl::Buffer::mNumFrames, and csl::DecodedFile::totalSize().

Referenced by m3_output().

bool DecodedFile::writeBuffer | ( | float * | L_buffer,
|  | float * | R_buffer,
|  | unsigned | num_samples
| ) |  |
| inherited

store samples into the receiver, adding another buffer if necessary

Definition at line 112 of file SoundFileMP3.cpp.

References csl::Buffer::buffer(), csl::DecodedFile::checkBufferStack(), csl::DecodedFile::mBuffers, memcpy(), csl::UnitGenerator::mFrameRate, csl::LSoundFile::mMaxDurInSecs, csl::UnitGenerator::mNumChannels, csl::Buffer::mNumFrames, and csl::DecodedFile::totalSize().

bool DecodedFile::writeBuffer | ( | int * | L_buffer,
|  | int * | R_buffer,
|  | unsigned | num_samples
| ) |  |
| inherited

Definition at line 139 of file SoundFileMP3.cpp.

References csl::Buffer::buffer(), csl::DecodedFile::checkBufferStack(), csl::DecodedFile::mBuffers, csl::UnitGenerator::mFrameRate, csl::LSoundFile::mMaxDurInSecs, csl::UnitGenerator::mNumChannels, csl::Buffer::mNumFrames, scale_MP3F, and csl::DecodedFile::totalSize().

void LSoundFile::writeBuffer | ( | Buffer & | inputBuffer | ) | throw (CException)
| virtual inherited

write a buffer of data into the file

Implements csl::Abst_SoundFile.

Definition at line 439 of file SoundFileL.cpp.

void Writeable::writeBuffer | ( | Buffer & | inputBuffer,
|  | unsigned | bufNum
| ) |  | throw (CException)
| protected virtual inherited

write to the receiver

Reimplemented in csl::BufferStream, and csl::RingBuffer.

Definition at line 1111 of file CSL_Core.cpp.

void DecodedFile::mergeBuffers | ( |  | ) |
| protected inherited

merge (concatenate) the buffers into 1 after loading

Definition at line 212 of file SoundFileMP3.cpp.

References csl::Buffer::allocateBuffers(), csl::Buffer::copySamplesFrom(), csl::Buffer::copySamplesFromTo(), csl::Buffer::freeBuffers(), csl::Abst_SoundFile::mBase, csl::DecodedFile::mBuffers, csl::Abst_SoundFile::mBytesPerSample, csl::Abst_SoundFile::mIsValid, csl::Buffer::mNumChannels, csl::UnitGenerator::mNumChannels, csl::Buffer::mNumFrames, csl::Abst_SoundFile::mNumFrames, csl::LSoundFile::mSFInfo, csl::LSoundFile::mSndfile, csl::Abst_SoundFile::mStart, csl::Abst_SoundFile::mStop, csl::WavetableOscillator::mWavetable, csl::Buffer::setSize(), and csl::DecodedFile::totalSize().

Referenced by decodeMP3().

bool DecodedFile::checkBufferStack | ( | unsigned | numFrames | ) |
| protected inherited

Definition at line 77 of file SoundFileMP3.cpp.

References csl::DecodedFile::addBuffer(), csl::DecodedFile::mBuffers, csl::Buffer::mNumAlloc, csl::UnitGenerator::mNumChannels, csl::Buffer::mNumFrames, and csl::CGestalt::sndFileFrames().

Referenced by csl::DecodedFile::writeBuffer().

bool DecodedFile::addBuffer | ( | unsigned | numChannels,
|  | unsigned | numFrames
| ) |  |
| protected inherited

Definition at line 91 of file SoundFileMP3.cpp.

References csl::Buffer::allocateBuffers(), csl::DecodedFile::mBuffers, and csl::Buffer::mNumFrames.

Referenced by csl::DecodedFile::checkBufferStack().

unsigned DecodedFile::totalSize | ( |  | ) |
| protected inherited

answer the total size of the buffer list

Definition at line 203 of file SoundFileMP3.cpp.

References csl::DecodedFile::mBuffers.

Referenced by csl::DecodedFile::mergeBuffers(), and csl::DecodedFile::writeBuffer().

LSoundFile * LSoundFile::openSndfile | ( | string | path,
|  | int | start = `-1`,
|  | int | stop = `-1`,
|  | bool | doRead = `true`
| ) |  |
| static inherited

Factory method.

Definition at line 86 of file SoundFileL.cpp.

References csl::LSoundFile::LSoundFile().

LSoundFile * LSoundFile::openSndfile | ( | float | maxDurInSecs,
|  | string | path
| ) |  |
| static inherited

Definition at line 102 of file SoundFileL.cpp.

References csl::LSoundFile::LSoundFile().

bool LSoundFile::isSndfileName | ( | const char * | path | ) |
| static inherited

Answer whether the given name looks like a snd file.

Answer the snd file type.

Definition at line 19 of file SoundFileL.cpp.

References gSndFileExts.

SoundFileFormat LSoundFile::sndfileNameType | ( | const char * | path | ) |
| static inherited

Answer the snd file type.

Definition at line 35 of file SoundFileL.cpp.

References kSoundFileFormatAIFF, kSoundFileFormatOther, kSoundFileFormatSND, and kSoundFileFormatWAV.

Referenced by csl::LSoundFile::mimeType().

const char * LSoundFile::mimeType | ( | const char * | path | ) |
| static inherited

Answer the MIME type based on the file name.

Definition at line 73 of file SoundFileL.cpp.

References kSoundFileFormatAIFF, kSoundFileFormatWAV, and csl::LSoundFile::sndfileNameType().

SoundFileFormat LSoundFile::format | ( |  | ) |
| inherited

get format

Definition at line 248 of file SoundFileL.cpp.

References kSoundFileFormatAIFF, kSoundFileFormatRaw, kSoundFileFormatSND, kSoundFileFormatWAV, csl::logMsg(), and csl::LSoundFile::mSFInfo.

void LSoundFile::openForRead | ( | bool | load = `true` | ) | throw (CException)
| virtual inherited

open file and get stats Open a file for write. Default values are some common format.

Implements csl::Abst_SoundFile.

Definition at line 266 of file SoundFileL.cpp.

References kSoundFileRead, and csl::CGestalt::maxSndFileFrames().

Referenced by csl::SndFileInstrument::initialize(), and csl::SndFileInstrument::setParameter().

void LSoundFile::close | ( |  | ) |
| virtual inherited

close file seek to some position

Implements csl::Abst_SoundFile.

Definition at line 328 of file SoundFileL.cpp.

References csl::Abst_SoundFile::freeBuffer(), and csl::LSoundFile::mSndfile.

unsigned LSoundFile::seekTo | ( | int | position,
|  | SeekPosition | whence = `kPositionStart`
| ) |  | throw (CException)
| virtual inherited

seek to some position relative to "whence"

Implements csl::Abst_SoundFile.

Definition at line 336 of file SoundFileL.cpp.

References csl::kPositionCurrent, csl::kPositionEnd, csl::kPositionStart, and csl::logMsg().

Referenced by csl::LSoundFile::initFromSndfile().

unsigned csl::Abst_SoundFile::seekTo | ( | int | position | ) | throw (CException)
| inline inherited

read a buffer from the file (possibly all of it)

Definition at line 117 of file SoundFile.h.

References csl::kPositionStart, and csl::Abst_SoundFile::seekTo().

Referenced by csl::Abst_SoundFile::seekTo().

void LSoundFile::readBufferFromFile | ( | unsigned | numFrames | ) |
| virtual inherited

read a buffer from the file (possibly all of it)

Implements csl::Abst_SoundFile.

Definition at line 457 of file SoundFileL.cpp.

References csl::Abst_SoundFile::checkBuffer(), csl::Interleaver::deinterleave(), csl::kLogError, csl::logMsg(), csl::Abst_SoundFile::mBase, csl::Seekable::mCurrentFrame, csl::LSoundFile::mInterleaver, csl::Abst_SoundFile::mIsLooping, csl::UnitGenerator::mNumChannels, csl::Buffer::monoBuffer(), csl::LSoundFile::mSFInfo, csl::LSoundFile::mSndfile, csl::Abst_SoundFile::mStart, csl::Abst_SoundFile::mStop, csl::WavetableOscillator::mWavetable, SAFE_FREE, and SAFE_MALLOC.

bool LSoundFile::isCached | ( |  | ) |
| virtual inherited

answer if file has all of its samples in RAM

< answer if file has all of its samples in RAM

answer if file has X samples in RAM

Reimplemented from csl::Abst_SoundFile.

Definition at line 238 of file SoundFileL.cpp.

References csl::Buffer::mNumFrames, csl::Abst_SoundFile::mNumFrames, and csl::WavetableOscillator::mWavetable.

Referenced by csl::LSoundFile::LSoundFile().

bool LSoundFile::isCached | ( | unsigned | samps | ) |
| virtual inherited

answer if file has X samples in RAM

Reimplemented from csl::Abst_SoundFile.

Definition at line 244 of file SoundFileL.cpp.

References csl::Seekable::mCurrentFrame, csl::Buffer::mNumFrames, and csl::WavetableOscillator::mWavetable.

SF_INFO* csl::LSoundFile::sfInfo | ( |  | ) |
| inline inherited

libsndfile sf-info struct

Definition at line 103 of file SoundFileL.h.

References csl::LSoundFile::mSFInfo.

SNDFILE* csl::LSoundFile::sndFile | ( |  | ) |
| inline inherited

libsndfile handle

Definition at line 104 of file SoundFileL.h.

References csl::LSoundFile::mSndfile.

void LSoundFile::initFromSndfile | ( |  | ) |
| protected virtual inherited

read SF header

Implements csl::Abst_SoundFile.

Definition at line 192 of file SoundFileL.cpp.

References if(), csl::kLogError, kSoundFileRead, csl::logMsg(), csl::Abst_SoundFile::mBase, csl::Abst_SoundFile::mBytesPerSample, csl::UnitGenerator::mFrameRate, csl::Abst_SoundFile::mIsValid, csl::LSoundFile::mMaxDurInSecs, csl::Abst_SoundFile::mMode, csl::UnitGenerator::mNumChannels, csl::Abst_SoundFile::mNumFrames, csl::LSoundFile::mSFInfo, csl::LSoundFile::mSndfile, csl::Abst_SoundFile::mStart, csl::Abst_SoundFile::mStop, and csl::LSoundFile::seekTo().

Referenced by csl::LSoundFile::openForReadWrite().

virtual SampleBuffer csl::Abst_SoundFile::buffer | ( | unsigned | bufNum | ) |
| inline virtual inherited

Definition at line 127 of file SoundFile.h.

References csl::Buffer::buffer(), and csl::WavetableOscillator::mWavetable.

unsigned Abst_SoundFile::channels | ( |  | ) | const
| inherited

accessors

# chans

Definition at line 84 of file SoundFile.cpp.

References csl::Abst_SoundFile::mIsValid, and csl::UnitGenerator::mNumChannels.

Referenced by csl::SoundCue::channels(), csl::CASoundFile::dump(), csl::Abst_SoundFile::dump(), and csl::SoundCue::dump().

unsigned csl::Abst_SoundFile::duration | ( |  | ) |
| inline virtual inherited

number of frames in the Seekable

Implements csl::Seekable.

Definition at line 131 of file SoundFile.h.

References csl::Abst_SoundFile::mNumFrames.

Referenced by csl::Abst_SoundFile::isCached(), csl::Abst_SoundFile::setStart(), csl::Abst_SoundFile::setStartRatio(), csl::Abst_SoundFile::setStop(), and csl::Abst_SoundFile::setStopRatio().

float Abst_SoundFile::durationInSecs | ( |  | ) |
| inherited

number of frames in the sound file

actual duration of the selected portion in sec

Definition at line 88 of file SoundFile.cpp.

References csl::UnitGenerator::mFrameRate, csl::Abst_SoundFile::mIsValid, csl::Abst_SoundFile::mStart, and csl::Abst_SoundFile::mStop.

Referenced by csl::CASoundFile::dump(), csl::Abst_SoundFile::dump(), and csl::SndFileInstrument::setParameter().

unsigned csl::Abst_SoundFile::sampleSize | ( |  | ) |
| inline inherited

get the bytes-per-sample

Definition at line 134 of file SoundFile.h.

References csl::Abst_SoundFile::mBytesPerSample.

SoundFileMode csl::Abst_SoundFile::mode | ( |  | ) |
| inline inherited

r/w mode

Definition at line 135 of file SoundFile.h.

References csl::Abst_SoundFile::mMode.

unsigned csl::Abst_SoundFile::cacheSize | ( |  | ) |
| inline inherited

size in frames of cached portion

Definition at line 136 of file SoundFile.h.

References csl::Buffer::mNumAlloc, and csl::WavetableOscillator::mWavetable.

void Abst_SoundFile::mergeToMono | ( |  | ) |
| inherited

average all the channels to mono

Definition at line 135 of file SoundFile.cpp.

References csl::Buffer::allocateBuffers(), csl::Buffer::buffer(), csl::Buffer::copyFrom(), csl::logMsg(), csl::Buffer::mAreBuffersAllocated, csl::Buffer::mDidIAllocateBuffers, csl::UnitGenerator::mNumChannels, csl::Buffer::mNumFrames, csl::WavetableOscillator::mWavetable, and csl::Buffer::setBuffer().

void Abst_SoundFile::setToEnd | ( |  | ) |
| virtual inherited

set to end position

Definition at line 260 of file SoundFile.cpp.

References csl::Seekable::mCurrentFrame, and csl::Abst_SoundFile::mStop.

Referenced by csl::JSoundFile::JSoundFile(), and csl::SndFileInstrument::setParameter().

void Abst_SoundFile::trigger | ( | void |  | ) |
| virtual inherited

reset to start

Reimplemented from csl::UnitGenerator.

Definition at line 248 of file SoundFile.cpp.

References csl::Seekable::mCurrentFrame, csl::Abst_SoundFile::mStart, and csl::Abst_SoundFile::seekTo().

Referenced by csl::SndFileInstrument::play(), csl::SndFileInstrument::playNote(), and csl::SndFileInstrument::playOSC().

void Abst_SoundFile::freeBuffer | ( |  | ) |
| virtual inherited

free the file cache

Definition at line 92 of file SoundFile.cpp.

References csl::Buffer::freeBuffers(), csl::Buffer::mAreBuffersAllocated, and csl::WavetableOscillator::mWavetable.

Referenced by csl::CASoundFile::close(), csl::JSoundFile::close(), csl::LSoundFile::close(), and csl::LSoundFile::~LSoundFile().

void Abst_SoundFile::convertRate | ( | int | fromRate,
|  | int | toRate
| ) |  |
| inherited

perform sample-rate conversion

Definition at line 163 of file SoundFile.cpp.

References csl::Buffer::convertRate(), csl::UnitGenerator::mFrameRate, csl::Buffer::mNumFrames, csl::Abst_SoundFile::mNumFrames, and csl::WavetableOscillator::mWavetable.

bool csl::Abst_SoundFile::isValid | ( |  | ) |
| inline inherited

answer if a valid file/buffer

Definition at line 145 of file SoundFile.h.

References csl::Abst_SoundFile::mIsValid.

bool Abst_SoundFile::isActive | ( |  | ) |
| virtual inherited

answer if currently active

Reimplemented from csl::UnitGenerator.

Definition at line 230 of file SoundFile.cpp.

References csl::Seekable::mCurrentFrame, csl::Abst_SoundFile::mIsValid, and csl::Abst_SoundFile::mStop.

void Abst_SoundFile::setPath | ( | string | path | ) |
| virtual inherited

set file name path string

Definition at line 80 of file SoundFile.cpp.

References csl::Abst_SoundFile::mPath.

Referenced by csl::Abst_SoundFile::Abst_SoundFile(), and csl::SndFileInstrument::setParameter().

string csl::Abst_SoundFile::path | ( |  | ) |
| inline inherited

file name

Definition at line 151 of file SoundFile.h.

References csl::Abst_SoundFile::mPath.

Referenced by csl::Abst_SoundFile::Abst_SoundFile(), csl::CASoundFile::dump(), csl::Abst_SoundFile::dump(), and csl::SndFileInstrument::setParameter().

void Abst_SoundFile::dump | ( | void |  | ) |
| virtual inherited

log snd file props

Reimplemented from csl::Oscillator.

Reimplemented in csl::CASoundFile.

Definition at line 296 of file SoundFile.cpp.

References csl::Abst_SoundFile::channels(), csl::Abst_SoundFile::durationInSecs(), csl::UnitGenerator::frameRate(), csl::logMsg(), and csl::Abst_SoundFile::path().

int csl::Abst_SoundFile::startFrame | ( |  | ) |
| inline inherited

get/set start frame

Definition at line 154 of file SoundFile.h.

References csl::Abst_SoundFile::mStart.

Referenced by csl::SndFileInstrument::playOSC().

void Abst_SoundFile::setStart | ( | int | val | ) |
| inherited

Definition at line 175 of file SoundFile.cpp.

References csl::Abst_SoundFile::duration(), csl::Abst_SoundFile::mIsValid, csl::Abst_SoundFile::mStart, and csl::Abst_SoundFile::seekTo().

Referenced by csl::SndFileInstrument::playNote(), csl::SndFileInstrument::playOSC(), csl::SndFileInstrument::setParameter(), csl::Abst_SoundFile::setStartRatio(), and csl::Abst_SoundFile::setStartSec().

void Abst_SoundFile::setStartSec | ( | float | val | ) |
| inherited

Definition at line 185 of file SoundFile.cpp.

References csl::UnitGenerator::mFrameRate, and csl::Abst_SoundFile::setStart().

void Abst_SoundFile::setStartRatio | ( | float | val | ) |
| inherited

Definition at line 189 of file SoundFile.cpp.

References csl::Abst_SoundFile::duration(), and csl::Abst_SoundFile::setStart().

Referenced by csl::SndFileInstrument::playOSC().

int csl::Abst_SoundFile::stopFrame | ( |  | ) |
| inline inherited

get/set stop frame

Definition at line 158 of file SoundFile.h.

References csl::Abst_SoundFile::mStop.

Referenced by csl::SndFileInstrument::playOSC().

void Abst_SoundFile::setStop | ( | int | val | ) |
| inherited

Definition at line 193 of file SoundFile.cpp.

References csl::Abst_SoundFile::duration(), and csl::Abst_SoundFile::mStop.

Referenced by csl::SndFileInstrument::playNote(), csl::SndFileInstrument::playOSC(), csl::SndFileInstrument::setParameter(), csl::Abst_SoundFile::setStopRatio(), and csl::Abst_SoundFile::setStopSec().

void Abst_SoundFile::setStopSec | ( | float | val | ) |
| inherited

Definition at line 202 of file SoundFile.cpp.

References csl::UnitGenerator::mFrameRate, and csl::Abst_SoundFile::setStop().

void Abst_SoundFile::setStopRatio | ( | float | val | ) |
| inherited

Definition at line 206 of file SoundFile.cpp.

References csl::Abst_SoundFile::duration(), and csl::Abst_SoundFile::setStop().

Referenced by csl::SndFileInstrument::playOSC().

void Abst_SoundFile::setBase | ( | int | val | ) |
| inherited

Definition at line 210 of file SoundFile.cpp.

References csl::Abst_SoundFile::mBase.

unsigned int csl::Abst_SoundFile::base | ( |  | ) |
| inline inherited

Definition at line 163 of file SoundFile.h.

References csl::Abst_SoundFile::mBase.

double csl::Abst_SoundFile::playbackRate | ( |  | ) |
| inline inherited

playback rate (pitch ratio)

Definition at line 165 of file SoundFile.h.

References csl::Abst_SoundFile::mRate.

void Abst_SoundFile::setRate | ( | UnitGenerator & | frequency | ) |
| inherited

set the receiver's playback rate (pitch ratio)

Definition at line 216 of file SoundFile.cpp.

References csl::Controllable::addInput(), CSL_RATE, and csl::Controllable::mInputs.

void Abst_SoundFile::setRate | ( | float | frequency | ) |
| inherited

Definition at line 223 of file SoundFile.cpp.

References csl::logMsg(), and csl::Abst_SoundFile::mRate.

bool csl::Abst_SoundFile::isLooping | ( |  | ) |
| inline inherited

get/set looping state

Definition at line 169 of file SoundFile.h.

References csl::Abst_SoundFile::mIsLooping.

void csl::Abst_SoundFile::setIsLooping | ( | bool | tLooping | ) |
| inline inherited

Definition at line 170 of file SoundFile.h.

References csl::Abst_SoundFile::mIsLooping.

void Abst_SoundFile::checkBuffer | ( | unsigned | numFrames | ) |
| protected inherited

allocate buffer lazily

Definition at line 99 of file SoundFile.cpp.

References csl::Buffer::allocateBuffers(), csl::Buffer::freeBuffers(), csl::logMsg(), csl::Buffer::mAreBuffersAllocated, csl::UnitGenerator::mNumChannels, csl::Buffer::mNumFrames, csl::WavetableOscillator::mWavetable, and csl::Buffer::setSize().

Referenced by csl::CASoundFile::readBufferFromFile(), csl::JSoundFile::readBufferFromFile(), and csl::LSoundFile::readBufferFromFile().

void Abst_SoundFile::checkBuffer | ( | unsigned | numChans,
|  | unsigned | numFrames
| ) |  |
| protected inherited

Definition at line 118 of file SoundFile.cpp.

References csl::Buffer::allocateBuffers(), csl::Buffer::freeBuffers(), csl::logMsg(), csl::Buffer::mAreBuffersAllocated, csl::UnitGenerator::mNumChannels, csl::Buffer::mNumFrames, csl::WavetableOscillator::mWavetable, and csl::Buffer::setSize().

bool Abst_SoundFile::readTags | ( |  | ) | throw (CException)
| protected inherited

read the ID3 or other tags. Returns true if able to read them.

Definition at line 266 of file SoundFile.cpp.

References csl::SoundFileMetadata::mAlbum, csl::SoundFileMetadata::mArtist, csl::SoundFileMetadata::mBitRate, csl::SoundFileMetadata::mChannels, csl::SoundFileMetadata::mComment, csl::SoundFileMetadata::mGenre, csl::SoundFileMetadata::mLength, csl::Abst_SoundFile::mPath, csl::Abst_SoundFile::mProperties, csl::SoundFileMetadata::mSampleRate, csl::SoundFileMetadata::mTitle, csl::SoundFileMetadata::mTrack, and csl::SoundFileMetadata::mYear.

Referenced by openForRead().

void WavetableOscillator::setWaveform | ( | Buffer & | wave,
|  | bool | freeBufs = `true`
| ) |  |
| inherited

plug in waveforms set the interpolation flag

Definition at line 76 of file Oscillator.cpp.

References csl::Buffer::buffer(), csl::Buffer::buffers(), csl::Buffer::freeBuffers(), csl::Buffer::mAreBuffersAllocated, csl::Buffer::mAreBuffersZero, csl::Buffer::mDidIAllocateBuffers, csl::Buffer::mIsPopulated, csl::Buffer::mMonoBufferByteSize, csl::Buffer::mNumChannels, csl::UnitGenerator::mNumChannels, csl::Buffer::mNumFrames, csl::WavetableOscillator::mWavetable, csl::Buffer::setBuffer(), and csl::Buffer::setBuffers().

Referenced by csl::Abst_SoundFile::Abst_SoundFile(), and csl::WavetableOscillator::WavetableOscillator().

void csl::WavetableOscillator::setInterpolate | ( | InterpolationPolicy | whether | ) |
| inline inherited

Definition at line 79 of file Oscillator.h.

References csl::WavetableOscillator::mInterpolate.

void WavetableOscillator::fillSine | ( |  | ) |
| protected inherited

fill the shared wavetable with 1 cycle of a sine wave

Definition at line 109 of file Oscillator.cpp.

References csl::Buffer::allocateBuffers(), CSL_TWOPI, DEFAULT_WTABLE_SIZE, csl::Buffer::mAreBuffersAllocated, csl::Buffer::mDidIAllocateBuffers, csl::Buffer::monoBuffer(), csl::WavetableOscillator::mWavetable, csl::Buffer::setBuffer(), csl::Buffer::setSize(), and sSineTable.

unsigned csl::UnitGenerator::frameRate | ( |  | ) |
| inline inherited

Definition at line 225 of file CSL_Core.h.

References csl::UnitGenerator::mFrameRate.

Referenced by csl::CASoundFile::dump(), csl::Abst_SoundFile::dump(), csl::SoundCue::dump(), csl::Filter::init(), csl::SndFileInstrument::playNote(), and csl::SndFileInstrument::playOSC().

void csl::UnitGenerator::setFrameRate | ( | unsigned | rate | ) |
| inline inherited

get/set the receiver's frame rate

Definition at line 226 of file CSL_Core.h.

References csl::UnitGenerator::mFrameRate.

Referenced by m3_header().

virtual unsigned csl::UnitGenerator::numChannels | ( |  | ) |
| inline virtual inherited

Reimplemented in csl::Splitter, and csl::Stereoverb.

Definition at line 228 of file CSL_Core.h.

References csl::UnitGenerator::mNumChannels.

Referenced by csl::AmbisonicMixer::addInput(), csl::BlockResizer::BlockResizer(), csl::Port::checkBuffer(), csl::Effect::Effect(), csl::AmbisonicRotator::initialize(), csl::AmbisonicDecoder::initialize(), m3_output(), csl::Mixer::nextBuffer(), and csl::SpatialSource::SpatialSource().

void csl::UnitGenerator::setNumChannels | ( | unsigned | ch | ) |
| inline inherited

get/set the receiver's number of outputs

Definition at line 229 of file CSL_Core.h.

References csl::UnitGenerator::mNumChannels.

Referenced by csl::BinauralPanner::BinauralPanner(), m3_output(), csl::Spatializer::Spatializer(), csl::VBAP::speakerLayoutChanged(), and csl::VBAP::VBAP().

BufferCopyPolicy csl::UnitGenerator::copyPolicy | ( |  | ) |
| inline inherited

Definition at line 231 of file CSL_Core.h.

References csl::UnitGenerator::mCopyPolicy.

void csl::UnitGenerator::setCopyPolicy | ( | BufferCopyPolicy | ch | ) |
| inline inherited

get/set the receiver's buffer copy policy

Definition at line 232 of file CSL_Core.h.

References csl::UnitGenerator::mCopyPolicy.

Referenced by csl::AmbisonicPanner::AmbisonicPanner(), csl::BinauralPanner::BinauralPanner(), csl::AmbisonicUnitGenerator::initOrder(), csl::Noise::Noise(), csl::PinkNoise::PinkNoise(), csl::Spatializer::Spatializer(), and csl::VBAP::VBAP().

virtual bool csl::UnitGenerator::isFixed | ( |  | ) |
| inline virtual inherited

query whether I'm fixed (StaticVariable overrides this)

Reimplemented in csl::StaticVariable, and csl::BinaryOp.

Definition at line 247 of file CSL_Core.h.

void UnitGenerator::addOutput | ( | UnitGenerator * | ugen | ) |
| inherited

add to or return the UGen vector of outputs

Definition at line 520 of file CSL_Core.cpp.

References csl::Buffer::allocateBuffers(), csl::CGestalt::maxBufferFrames(), csl::UnitGenerator::mNumOutputs, csl::UnitGenerator::mOutputCache, and csl::UnitGenerator::mOutputs.

Referenced by csl::Mixer::addInput(), csl::Controllable::addInput(), csl::AmbisonicRotator::initialize(), csl::AmbisonicDecoder::initialize(), csl::AmbisonicEncoder::setInput(), and csl::IO::setRoot().

void UnitGenerator::removeOutput | ( | UnitGenerator * | ugen | ) |
| inherited

Definition at line 530 of file CSL_Core.cpp.

References csl::UnitGenerator::mNumOutputs, and csl::UnitGenerator::mOutputs.

Referenced by csl::IO::clearRoot(), csl::AmbisonicEncoder::setInput(), csl::AmbisonicDecoder::~AmbisonicDecoder(), and csl::AmbisonicRotator::~AmbisonicRotator().

UGenVector csl::UnitGenerator::outputs | ( |  | ) |
| inline inherited

Definition at line 253 of file CSL_Core.h.

References csl::UnitGenerator::mOutputs.

virtual unsigned csl::UnitGenerator::numOutputs | ( |  | ) |
| inline virtual inherited

Definition at line 254 of file CSL_Core.h.

References csl::UnitGenerator::mNumOutputs.

bool UnitGenerator::checkFanOut | ( | Buffer & | outputBuffer | ) | throw (CException)
| inherited

check for fan-out and copy previous buffer; return true if fanning out

Definition at line 549 of file CSL_Core.cpp.

void UnitGenerator::handleFanOut | ( | Buffer & | outputBuffer | ) | throw (CException)
| inherited

Definition at line 563 of file CSL_Core.cpp.

References csl_max.

virtual void csl::UnitGenerator::setValue | ( | sample | theValue | ) |
| inline virtual inherited

set/get the value (not allowed in the abstract, useful for static values)

Reimplemented in csl::DynamicVariable, and csl::StaticVariable.

Definition at line 260 of file CSL_Core.h.

virtual sample csl::UnitGenerator::value | ( |  | ) |
| inline virtual inherited

Reimplemented in csl::StaticVariable.

Definition at line 261 of file CSL_Core.h.

void UnitGenerator::zeroBuffer | ( | Buffer & | outputBuffer,
|  | unsigned | outBufNum
| ) |  |
| protected inherited

utility method to zero out an outputBuffer

Definition at line 513 of file CSL_Core.cpp.

References csl::Buffer::mMonoBufferByteSize, and csl::Buffer::monoBuffer().

void Model::attachObserver | ( | Observer * | o | ) |
| inherited

(possibly notify obersvers on my death)

register/remove observers

Definition at line 491 of file CGestalt.cpp.

References csl::logMsg(), csl::Observer::mKey, and csl::Observer::mPeriod.

Referenced by csl::SpatialPanner::setSpeakerLayout().

void Model::detachObserver | ( | Observer * | o | ) |
| inherited

Definition at line 507 of file CGestalt.cpp.

References csl::logMsg().

Referenced by csl::SpatialPanner::setSpeakerLayout(), and csl::SpatialPanner::~SpatialPanner().

void Model::changed | ( | void * | argument | ) |
| inherited

this is what I send to myself to notify my observers; It's not overridden in general. It results in the observers receiving update() calls < override evaluate to filter updates to the observer map

Definition at line 529 of file CGestalt.cpp.

References csl::logMsg().

Referenced by csl::SpeakerLayout::addSpeaker(), csl::MIDIIn::handleIncomingMidiMessage(), and csl::SpeakerLayout::setDefaultSpeakerLayout().

virtual int csl::Model::evaluate | ( | void * | argument | ) |
| inline virtual inherited

Reimplemented in csl::MIDIIn.

Definition at line 259 of file CGestalt.h.

void Phased::setFrequency | ( | UnitGenerator & | frequency | ) |
| inherited

Setter accessors.

set frequency

Definition at line 829 of file CSL_Core.cpp.

References csl::Controllable::addInput(), and CSL_FREQUENCY.

Referenced by csl::AdditiveInstrument::playMIDI(), csl::AdditiveInstrument::playNote(), csl::AdditiveInstrument::playOSC(), csl::AdditiveInstrument::setParameter(), csl::SquareBL::SquareBL(), test_SHARC(), test_SHARC2(), testRandFreqEnv(), testSplitJoin1(), testSplitJoin2(), testSumOfSines1F(), testSumOfSinesCached(), testSumOfSinesNonCached(), and testSumOfSinesSteps().

void Phased::setFrequency | ( | float | frequency | ) |
| inherited

set frequency

Reimplemented in csl::KarplusString.

Definition at line 833 of file CSL_Core.cpp.

References csl::Controllable::addInput(), and CSL_FREQUENCY.

void csl::Phased::setPhase | ( | float | phase | ) |
| inline inherited

Definition at line 475 of file CSL_Core.h.

References csl::Phased::mPhase.

Port * Controllable::getPort | ( | CSL_MAP_KEY | name | ) |
| inherited

Definition at line 768 of file CSL_Core.cpp.

References csl::Controllable::mInputs.

Referenced by csl::FrequencyAmount::getFrequency(), and csl::VSTIO::getParameter().

void Controllable::addInput | ( | CSL_MAP_KEY | name,
|  | UnitGenerator & | ugen
| ) |  |
| protected inherited

Plug in a unit generator to the named input slot.

Definition at line 742 of file CSL_Core.cpp.

References csl::UnitGenerator::addOutput(), csl::logMsg(), and csl::Controllable::mInputs.

Referenced by csl::BinaryOp::BinaryOp(), csl::DistanceSimulator::DistanceSimulator(), csl::Effect::Effect(), csl::InOut::InOut(), csl::NtoMPanner::NtoMPanner(), csl::Panner::Panner(), csl::Phased::Phased(), csl::Scalable::Scalable(), csl::FrequencyAmount::setAmount(), csl::FrequencyAmount::setFrequency(), csl::Phased::setFrequency(), csl::Effect::setInput(), csl::Scalable::setOffset(), csl::Panner::setPosition(), csl::Abst_SoundFile::setRate(), csl::Scalable::setScale(), csl::NtoMPanner::setX(), csl::NtoMPanner::setY(), and csl::SpatialSource::SpatialSource().

void Controllable::addInput | ( | CSL_MAP_KEY | name,
|  | float | value
| ) |  |
| protected inherited

Plug in a float to the named input slot.

Definition at line 754 of file CSL_Core.cpp.

References csl::logMsg(), csl::Controllable::mInputs, and csl::Port::mValue.

void Controllable::pullInput | ( | Port * | thePort,
|  | unsigned | numFrames
| ) |  | throw (CException)
| protected inherited

method to read the control values (in case they're dynamic). this sends nextBuffer() to the input.

Definition at line 695 of file CSL_Core.cpp.

References csl::kSamples, csl::logMsg(), csl::Buffer::mIsPopulated, csl::Buffer::mNumFrames, csl::Buffer::mType, csl::UnitGenerator::nextBuffer(), and csl::Buffer::zeroBuffers().

Referenced by csl::Panner::nextBuffer(), csl::NtoMPanner::nextBuffer(), and csl::Effect::pullInput().

void Controllable::pullInput | ( | Port * | thePort,
|  | Buffer & | theBuffer
| ) |  | throw (CException)
| protected inherited

Definition at line 727 of file CSL_Core.cpp.

References csl::UnitGenerator::nextBuffer().

void Scalable::setScale | ( | UnitGenerator & | scale | ) |
| inherited

set the receiver's scale member to a UGen or a float

Definition at line 887 of file CSL_Core.cpp.

References csl::Controllable::addInput(), CSL_SCALE, and csl::logMsg().

Referenced by createRandFreqEnvPatch(), csl::FancyFMInstrument::FancyFMInstrument(), csl::AdditiveInstrument::init(), csl::SndFileInstrument::initialize(), main(), csl::FMInstrument::parseArgs(), csl::SndFileInstrument::playNote(), csl::SndFileInstrument::playOSC(), csl::AdditiveInstrument::setParameter(), csl::SndFileInstrument::setParameter(), csl::FancyFMInstrument::setParameter(), sosNote(), test_SHARC(), test_SHARC2(), testADSR_FM(), testARSin2(), testComplexEnvelope(), testEnvScale(), testFancy_FM(), testFanMix1(), testFanMix2(), testMultiTap(), testRandFreqEnv(), testReverb(), testSplitJoin1(), testSplitJoin2(), testStereoverb(), testString(), testStringChorus(), testSumOfSines1F(), testSumOfSinesCached(), testSumOfSinesNonCached(), testSumOfSinesSteps(), and testWaveShaper().

void Scalable::setScale | ( | float | scale | ) |
| inherited

Definition at line 894 of file CSL_Core.cpp.

References csl::Controllable::addInput(), CSL_SCALE, and csl::logMsg().

void Scalable::setOffset | ( | UnitGenerator & | offset | ) |
| inherited

set the receiver's offset member to a UGen or a float

Definition at line 901 of file CSL_Core.cpp.

References csl::Controllable::addInput(), CSL_OFFSET, and csl::logMsg().

void Scalable::setOffset | ( | float | offset | ) |
| inherited

Reimplemented in csl::RandEnvelope.

Definition at line 908 of file CSL_Core.cpp.

References csl::Controllable::addInput(), CSL_OFFSET, and csl::logMsg().

void csl::Scalable::isScaled | ( |  | ) |
| inherited

answer whether scale = 1 & offset = 0

void Seekable::reset | ( |  | ) | throw (CException)
| virtual inherited

reset-to-zero

Definition at line 1123 of file CSL_Core.cpp.

References csl::kPositionStart, and csl::Seekable::seekTo().

## Member Data Documentation

unsigned csl::MP3File::mMP3Rate

the actual rate of the MP3 file

Definition at line 78 of file SoundFileMP3.h.

Referenced by m3_header(), MP3File(), and openForRead().

BufferVector csl::DecodedFile::mBuffers
| protected inherited

temp decoder buffers merge (concatenate) the buffers into 1 after loading

Definition at line 48 of file SoundFileMP3.h.

Referenced by csl::DecodedFile::addBuffer(), csl::DecodedFile::checkBufferStack(), decodeMP3(), csl::DecodedFile::mergeBuffers(), csl::DecodedFile::totalSize(), csl::DecodedFile::writeBuffer(), and csl::DecodedFile::~DecodedFile().

SF_INFO* csl::LSoundFile::mSFInfo
| protected inherited

libsndfile sf-info struct

Definition at line 107 of file SoundFileL.h.

Referenced by csl::LSoundFile::format(), csl::LSoundFile::initFromSndfile(), csl::DecodedFile::mergeBuffers(), openForRead(), csl::LSoundFile::openForReadWrite(), csl::LSoundFile::readBufferFromFile(), csl::LSoundFile::sfInfo(), and csl::LSoundFile::~LSoundFile().

SNDFILE* csl::LSoundFile::mSndfile
| protected inherited

libsndfile handle

Definition at line 108 of file SoundFileL.h.

Referenced by csl::LSoundFile::close(), csl::LSoundFile::initFromSndfile(), csl::DecodedFile::mergeBuffers(), openForRead(), csl::LSoundFile::openForReadWrite(), csl::LSoundFile::readBufferFromFile(), csl::LSoundFile::sndFile(), and csl::LSoundFile::~LSoundFile().

Interleaver csl::LSoundFile::mInterleaver
| protected inherited

File IO interleaver/deinterleaver.

Definition at line 109 of file SoundFileL.h.

Referenced by csl::LSoundFile::readBufferFromFile().

float csl::LSoundFile::mMaxDurInSecs
| protected inherited

max size to read from file. In seconds so it can deal with varying sample rates.

Definition at line 110 of file SoundFileL.h.

Referenced by csl::LSoundFile::initFromSndfile(), and csl::DecodedFile::writeBuffer().

SoundFileMetadata* csl::Abst_SoundFile::mProperties
| inherited

the ID3 tags properties

Definition at line 172 of file SoundFile.h.

Referenced by csl::Abst_SoundFile::readTags(), and csl::Abst_SoundFile::~Abst_SoundFile().

string csl::Abst_SoundFile::mPath
| protected inherited

file name

Definition at line 175 of file SoundFile.h.

Referenced by csl::Abst_SoundFile::Abst_SoundFile(), csl::CASoundFile::CASoundFile(), decodeMP3(), csl::LSoundFile::LSoundFile(), csl::CASoundFile::openForRead(), csl::LSoundFile::openForReadWrite(), csl::Abst_SoundFile::path(), csl::CASoundFile::readBufferFromFile(), csl::Abst_SoundFile::readTags(), and csl::Abst_SoundFile::setPath().

SoundFileMode csl::Abst_SoundFile::mMode
| protected inherited

r/w mode

Definition at line 176 of file SoundFile.h.

Referenced by csl::LSoundFile::initFromSndfile(), csl::Abst_SoundFile::mode(), MP3File(), csl::CASoundFile::openForRead(), openForRead(), and csl::LSoundFile::openForReadWrite().

SoundFileFormat csl::Abst_SoundFile::mFormat
| protected inherited

sf format

Definition at line 177 of file SoundFile.h.

bool csl::Abst_SoundFile::mIsValid
| protected inherited

is my file valid?

Definition at line 178 of file SoundFile.h.

Referenced by csl::Abst_SoundFile::channels(), csl::Abst_SoundFile::durationInSecs(), csl::CASoundFile::initFromSndfile(), csl::JSoundFile::initFromSndfile(), csl::LSoundFile::initFromSndfile(), csl::Abst_SoundFile::isActive(), csl::Abst_SoundFile::isValid(), csl::DecodedFile::mergeBuffers(), csl::CASoundFile::openForRead(), openForRead(), and csl::Abst_SoundFile::setStart().

bool csl::Abst_SoundFile::mIsLooping
| protected inherited

am i looping start-stop?

Definition at line 179 of file SoundFile.h.

Referenced by csl::Abst_SoundFile::isLooping(), csl::CASoundFile::readBufferFromFile(), csl::JSoundFile::readBufferFromFile(), csl::LSoundFile::readBufferFromFile(), and csl::Abst_SoundFile::setIsLooping().

int csl::Abst_SoundFile::mStart
| protected inherited

Definition at line 180 of file SoundFile.h.

Referenced by csl::SoundCue::duration(), csl::Abst_SoundFile::durationInSecs(), csl::CASoundFile::initFromSndfile(), csl::JSoundFile::initFromSndfile(), csl::LSoundFile::initFromSndfile(), csl::DecodedFile::mergeBuffers(), csl::CASoundFile::openForRead(), openForRead(), csl::LSoundFile::readBufferFromFile(), csl::Abst_SoundFile::setStart(), csl::Abst_SoundFile::startFrame(), and csl::Abst_SoundFile::trigger().

int csl::Abst_SoundFile::mStop
| protected inherited

starting/ending frames (or -1 if not used)

Definition at line 180 of file SoundFile.h.

Referenced by csl::Abst_SoundFile::durationInSecs(), csl::CASoundFile::initFromSndfile(), csl::JSoundFile::initFromSndfile(), csl::LSoundFile::initFromSndfile(), csl::Abst_SoundFile::isActive(), csl::DecodedFile::mergeBuffers(), openForRead(), csl::CASoundFile::readBufferFromFile(), csl::JSoundFile::readBufferFromFile(), csl::LSoundFile::readBufferFromFile(), csl::Abst_SoundFile::setStop(), csl::Abst_SoundFile::setToEnd(), and csl::Abst_SoundFile::stopFrame().

double csl::Abst_SoundFile::mRate
| protected inherited

sample rate ratio

Definition at line 181 of file SoundFile.h.

Referenced by csl::Abst_SoundFile::playbackRate(), and csl::Abst_SoundFile::setRate().

unsigned csl::Abst_SoundFile::mNumFrames
| protected inherited

# sample frames

Definition at line 182 of file SoundFile.h.

Referenced by csl::Abst_SoundFile::convertRate(), csl::Abst_SoundFile::duration(), csl::CASoundFile::initFromSndfile(), csl::JSoundFile::initFromSndfile(), csl::LSoundFile::initFromSndfile(), csl::LSoundFile::isCached(), csl::DecodedFile::mergeBuffers(), csl::CASoundFile::openForRead(), and openForRead().

unsigned csl::Abst_SoundFile::mBytesPerSample
| protected inherited

the # of bytes per sample

Definition at line 183 of file SoundFile.h.

Referenced by csl::JSoundFile::initFromSndfile(), csl::LSoundFile::initFromSndfile(), csl::DecodedFile::mergeBuffers(), csl::CASoundFile::openForRead(), csl::CASoundFile::readBufferFromFile(), and csl::Abst_SoundFile::sampleSize().

unsigned csl::Abst_SoundFile::mBase
| protected inherited

starting frame in file of buffer

Definition at line 184 of file SoundFile.h.

Referenced by csl::Abst_SoundFile::base(), csl::LSoundFile::initFromSndfile(), csl::DecodedFile::mergeBuffers(), csl::LSoundFile::readBufferFromFile(), and csl::Abst_SoundFile::setBase().

InterpolationPolicy csl::WavetableOscillator::mInterpolate
| inherited

whether/how I should interpolate between samples

Definition at line 83 of file Oscillator.h.

Referenced by csl::WavetableOscillator::setInterpolate(), and csl::WavetableOscillator::WavetableOscillator().

Buffer csl::WavetableOscillator::mWavetable
| inherited

the stored wave form

Definition at line 84 of file Oscillator.h.

Referenced by csl::Abst_SoundFile::Abst_SoundFile(), csl::Abst_SoundFile::buffer(), csl::Abst_SoundFile::cacheSize(), csl::Abst_SoundFile::checkBuffer(), csl::Abst_SoundFile::convertRate(), csl::CompOrCacheOscillator::createCache(), csl::WavetableOscillator::fillSine(), csl::Abst_SoundFile::freeBuffer(), csl::LSoundFile::isCached(), csl::Abst_SoundFile::isCached(), csl::DecodedFile::mergeBuffers(), csl::Abst_SoundFile::mergeToMono(), openForRead(), csl::CASoundFile::readBufferFromFile(), csl::JSoundFile::readBufferFromFile(), csl::LSoundFile::readBufferFromFile(), csl::WavetableOscillator::setWaveform(), csl::WavetableOscillator::WavetableOscillator(), and csl::WavetableOscillator::~WavetableOscillator().

unsigned csl::UnitGenerator::mFrameRate
| protected inherited

trigger ignored here

the frame rate – initialized to be the default by the constructor

Definition at line 264 of file CSL_Core.h.

Referenced by csl::Abst_SoundFile::convertRate(), csl::RtpSender::createRtpSession(), csl::RtpReceiver::createRtpSession(), csl::Lorenz::dump(), csl::Abst_SoundFile::durationInSecs(), csl::UnitGenerator::frameRate(), csl::Filter::init(), csl::CASoundFile::initFromSndfile(), csl::JSoundFile::initFromSndfile(), csl::LSoundFile::initFromSndfile(), csl::RandEnvelope::nextSegment(), csl::SquareBL::nextWaveInto(), csl::SumOfSines::nextWaveInto(), csl::CASoundFile::openForRead(), openForRead(), csl::DelayLine::setDelayTime(), csl::UnitGenerator::setFrameRate(), csl::Abst_SoundFile::setStartSec(), csl::Abst_SoundFile::setStopSec(), csl::Butter::setupCoeffs(), csl::Formant::setupCoeffs(), csl::Notch::setupCoeffs(), csl::Moog::setupCoeffs(), and csl::DecodedFile::writeBuffer().

unsigned csl::UnitGenerator::mNumChannels
| protected inherited

my "expected" number of output channels

Definition at line 268 of file CSL_Core.h.

Referenced by csl::AmbisonicMixer::addInput(), csl::Mixer::allocateOpBuffer(), csl::AmbisonicDecoder::asProjection(), csl::AmbisonicDecoder::asPseudoInverse(), csl::BlockResizer::BlockResizer(), csl::Abst_SoundFile::channels(), csl::Abst_SoundFile::checkBuffer(), csl::DecodedFile::checkBufferStack(), csl::FMInstrument::FMInstrument(), csl::GrainPlayer::GrainPlayer(), csl::AdditiveInstrument::init(), csl::JSoundFile::initFromSndfile(), csl::LSoundFile::initFromSndfile(), csl::AmbisonicMixer::initialize(), csl::SndFileInstrument::initialize(), csl::AmbisonicRotator::initialize(), csl::AmbisonicEncoder::initialize(), csl::AmbisonicDecoder::initialize(), csl::AmbisonicUnitGenerator::initOrder(), csl::RemoteStream::initPacket(), csl::Joiner::isActive(), csl::AmbisonicDecoder::makeInPhase(), csl::AmbisonicDecoder::makeMaxRE(), csl::DecodedFile::mergeBuffers(), csl::Abst_SoundFile::mergeToMono(), csl::Mixer::Mixer(), csl::UnitGenerator::numChannels(), csl::CASoundFile::openForRead(), openForRead(), csl::Panner::Panner(), csl::CASoundFile::readBufferFromFile(), csl::JSoundFile::readBufferFromFile(), csl::LSoundFile::readBufferFromFile(), csl::RemoteStream::RemoteStream(), csl::UnitGenerator::setNumChannels(), csl::WavetableOscillator::setWaveform(), csl::Joiner::trigger(), csl::DecodedFile::writeBuffer(), and csl::AmbisonicRotator::~AmbisonicRotator().

BufferCopyPolicy csl::UnitGenerator::mCopyPolicy
| protected inherited

the policy I use if asked for more or fewer channels

Definition at line 269 of file CSL_Core.h.

Referenced by csl::UnitGenerator::copyPolicy(), and csl::UnitGenerator::setCopyPolicy().

UGenVector csl::UnitGenerator::mOutputs
| protected inherited

the vector of my output UGens

Definition at line 270 of file CSL_Core.h.

Referenced by csl::UnitGenerator::addOutput(), csl::UnitGenerator::dump(), csl::UnitGenerator::outputs(), and csl::UnitGenerator::removeOutput().

unsigned csl::UnitGenerator::mNumOutputs
| protected inherited

the number of outputs

Definition at line 271 of file CSL_Core.h.

Referenced by csl::UnitGenerator::addOutput(), csl::UnitGenerator::numOutputs(), and csl::UnitGenerator::removeOutput().

Buffer* csl::UnitGenerator::mOutputCache
| protected inherited

my past output ring buffer (only used in case of fan-out)

Definition at line 272 of file CSL_Core.h.

Referenced by csl::UnitGenerator::addOutput().

unsigned csl::UnitGenerator::mSequence
| protected inherited

the highest-seen buffer seq number

Definition at line 273 of file CSL_Core.h.

sample csl::Phased::mPhase
| protected inherited

set phase

the actual phase accumulator

Definition at line 475 of file CSL_Core.h.

Referenced by csl::Phased::setPhase().

PortMap csl::Controllable::mInputs
| protected inherited

the map of my inputs or controls (used by the mix-in classes)

Definition at line 353 of file CSL_Core.h.

Referenced by csl::Controllable::addInput(), csl::BinaryOp::dump(), csl::Controllable::dump(), csl::Controllable::getPort(), csl::Effect::inPort(), csl::Effect::isActive(), csl::Joiner::isActive(), csl::SquareBL::nextWaveInto(), csl::BinaryOp::operandIsFixed(), csl::Phased::Phased(), csl::DistanceSimulator::positionChanged(), csl::Scalable::Scalable(), csl::BinaryOp::setOperand(), csl::Abst_SoundFile::setRate(), csl::Butter::setupCoeffs(), csl::Formant::setupCoeffs(), csl::Notch::setupCoeffs(), csl::Allpass::setupCoeffs(), csl::Moog::setupCoeffs(), csl::Scalable::trigger(), csl::Effect::trigger(), csl::Joiner::trigger(), and csl::Controllable::~Controllable().

unsigned csl::Seekable::mCurrentFrame
| inherited

where I currently am in the buffer

Definition at line 548 of file CSL_Core.h.

Referenced by csl::Abst_SoundFile::Abst_SoundFile(), csl::DelayLine::delayLength(), csl::Abst_SoundFile::isActive(), csl::LSoundFile::isCached(), csl::Abst_SoundFile::isCached(), csl::CASoundFile::openForRead(), csl::CASoundFile::readBufferFromFile(), csl::JSoundFile::readBufferFromFile(), csl::LSoundFile::readBufferFromFile(), csl::RingBufferTap::setOffset(), csl::Abst_SoundFile::setToEnd(), and csl::Abst_SoundFile::trigger().

double csl::Seekable::mActualFrame
| inherited

where I actually am in the buffer

Definition at line 551 of file CSL_Core.h.

The documentation for this class was generated from the following files:

- CSL/IO/SoundFileMP3.h
- CSL/IO/SoundFileMP3.cpp